#!/bin/bash
#The VNC Startup File
UNIX_TYPE=`lsb_release -d 2>/dev/null | awk -F"\t" '{print $2}' | awk -F " " '{print $1}' 2>/dev/null`
echo "Setup for UNIX type: $UNIX_TYPE"

DISPLAY=":1"

defaultXstartup=$HOME/.vnc/xstartup
backupXstartup=$HOME/.vnc/xstartup.bak
PUBLICIP=`curl http://169.254.169.254/latest/meta-data/public-ipv4 2>/dev/null`

REDHAT_INSTALL="sudo yum install -y"
REDHAT_PACKAGES="tigervnc-server tigervnc xterm metacity nautilus gnome-calculator dconf-editor gvim vim wget"
REDHAT_REPO="https://dl.fedoraproject.org/pub/epel/epel-release-latest-8.noarch.rpm"

UBUNTU_UPDATE="sudo apt-get update"
UBUNTU_INSTALL="sudo apt-get -y install"
UBUNTU_PACKAGES1="xfce4 xfce4-goodies tightvncserver"
UBUNTU_PACKAGES2="gnome-icon-theme tango-icon-theme links2" 


if [ "$UNIX_TYPE" == "Ubuntu" ]
then
  $UBUNTU_UPDATE
  $UBUNTU_INSTALL $UBUNTU_PACKAGES1
  $UBUNTU_INSTALL $UBUNTU_PACKAGES2
  #This fixes a problem with xfce4 on Ubuntu where the icons show as broken
  #and the themes and colors don't update. Comment XKL_XMODMAP_DISABLE
  if [ -e $defaultXstartup ] 
  then
    cp $defaultXstartup $backupXstartup
    sed 's/^export XKL_XMODMAP_DISABLE/#&/' $backupXstartup > $defaultXstartup
  else
    mkdir $HOME/.vnc
    cp xstartup.ubuntu $defaultXstartup
  fi
else
  #Not Ubuntu - so RedHat or Amazon Linux
  if [ ! -e $defaultXstartup ] && [ "$UNIX_TYPE" != "Ubuntu" ]
  then
    echo "Creating directories and copying xstartup"
    mkdir -p $HOME/.config/nautilus
    mkdir -p $HOME/Desktop
    mkdir -p $HOME/.vnc
    cp xstartup.redhat $defaultXstartup
  fi
  $REDHAT_INSTALL $REDHAT_REPO
  $REDHAT_INSTALL $REDHAT_PACKAGES
fi

echo "VNC Install Finished."
echo "Public IP address=$PUBLICIP"
echo "For VNC use: $PUBLICIP${DISPLAY}"
