#!/bin/bash
#The VNC Startup File
defaultXStartup=$HOME/.vnc/xstartup

REPO="https://dl.fedoraproject.org/pub/epel/epel-release-latest-8.noarch.rpm"
PACKAGES="tigervnc-server tigervnc xterm metacity nautilus gnome-calculator dconf-editor gvim vim wget"
PUBLICIP=`curl http://169.254.169.254/latest/meta-data/public-ipv4 2>/dev/null`
sudo yum install -y $REPO
sudo yum install -y $PACKAGES

#Make some of the directories that don't exist on an new AMI
mkdir -p $HOME/.config/nautilus
mkdir -p $HOME/Desktop
mkdir -p $HOME/.vnc

#Check to see if .vnc/xstartup is already set, if so we don't want to 
#recreate it
grep -q metacity $defaultXStartup
if [ $? -eq 0 ]
then
    echo "No need to update $defaultXStartup"
else
    echo "#!/bin/sh" > $defaultXStartup
    echo "unset SESSION_MANAGER" >> $defaultXStartup
    echo "unset DBUS_SESSION_BUS_ADDRESS" >> $defaultXStartup
    echo "#xrdb $HOME/.Xresources &" >> $defaultXStartup
    echo "xsetroot -solid darkslateblue &" >> $defaultXStartup
    echo "metacity &" >> $defaultXStartup
    echo "nautilus &" >> $defaultXStartup
    echo "gnome-calculator &" >> $defaultXStartup
    echo "xterm -geometry 80x40+10+10 -fg black -bg white &" >> $defaultXStartup
    echo "xterm -geometry 80x40+100+100 -fg black -bg white &" >> $defaultXStartup
    echo "gvim -geometry 80x40+200+200 &" >> $defaultXStartup
    chmod 0755 $defaultXStartup
fi
echo "Public IP address= $PUBLICIP"
echo "For VNC use: $PUBLICIP:1"
